/**
 * This file is part of Moodle - http://moodle.org/
 *
 * Moodle is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Moodle is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Main library.
 *
 * @package
 * @author    Guy Thomas
 * @copyright Copyright (c) 2016 Open LMS / 2023 Anthology Inc. and its affiliates
 * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */
define("filter_ally/main",["jquery","core/templates","core/str","filter_ally/ally","filter_ally/imagecover","filter_ally/util"],(function($,Templates,Strings,Ally,ImageCover,Util){return new function(){var self=this;self.canViewFeedback=!1,self.canDownload=!1,self.initialised=!1,self.params={};var getNodeByXpath=function(xpath){return window.document.createExpression(xpath).evaluate(window.document,XPathResult.FIRST_ORDERED_NODE_TYPE).singleNodeValue},renderTemplate=function(data,pathHash,targetEl){var dfd=$.Deferred();return $(targetEl).parents(".filter-ally-wrapper").length?(dfd.resolve(),dfd.promise()):(data.canviewfeedback=self.canViewFeedback,data.candownload=self.canDownload,data.html='<span id="content-target-'+pathHash+'"></span>',Templates.render("filter_ally/wrapper",data).done((function(result){0==$(targetEl).next().find('span[data-file-id="'+pathHash+'"]').length&&($(targetEl).after(result),$("#content-target-"+pathHash).after(targetEl),$("#content-target-"+pathHash).remove()),dfd.resolve()})),dfd.promise())},placeHoldSelector=function(selector,map){var dfd=$.Deferred(),c=0,length=$(selector).length;return length||dfd.resolve(),$(selector).each((function(){var url,type,regex,checkComplete=function(){c===length&&dfd.resolve()};"a"===$(this).prop("tagName").toLowerCase()?(url=$(this).attr("href"),type="a"):(url=$(this).attr("src"),type="img"),regex=url.indexOf("?")>-1?/pluginfile.php\/(\d*)\/(.*)(\?)/:/pluginfile.php\/(\d*)\/(.*)/;var pathHash,match=url.match(regex);if(match){var path=match[1]+"/"+match[2];path=decodeURIComponent(path),pathHash=map[path]}if(void 0===pathHash){var query=Util.getQuery(url);if(query.file)regex=/\/(\d*)\/(.*)/,(match=decodeURIComponent(query.file).match(regex))&&(path=match[1]+"/"+match[2],path=decodeURIComponent(path),pathHash=map[path])}if(void 0===pathHash)return c++,void checkComplete();renderTemplate({isimage:"img"===type,fileid:pathHash,url:url},pathHash,$(this)).done((function(){c++,checkComplete()}))})),dfd.promise()},placeHoldForumModule=function(forumFileMapping){var dfd=$.Deferred();return placeHoldSelector('.forumpost .attachedimages img[src*="pluginfile.php"], .forumpost .body-content-container a[href*="pluginfile.php"]',forumFileMapping).done((function(){dfd.resolve()})),dfd.promise()},placeHoldAssignModule=function(assignFileMapping){var dfd=$.Deferred();return Util.whenTrue((function(){return $('div[id*="assign_files_tree"] .ygtvitem').length>0}),10).done((function(){placeHoldSelector('div[id*="assign_files_tree"] a[href*="pluginfile.php"]',assignFileMapping),dfd.resolve()})),dfd.promise()},placeHoldFolderModule=function(folderFileMapping){var dfd=$.Deferred();return Util.whenTrue((function(){return $(".foldertree > .filemanager .ygtvitem").length>0}),10).done((function(){placeHoldSelector('.foldertree > .filemanager span:not(.filter-ally-wrapper) > a[href*="pluginfile.php"]',folderFileMapping).done((function(){dfd.resolve()}))})),dfd.promise()},placeHoldGlossaryModule=function(glossaryFileMapping){var dfd=$.Deferred();$(".entry .attachments > br").each((function(){var mainAnchor=$(this).prev('a[href*="pluginfile.php"]');mainAnchor.addClass("ally-glossary-attachment");var iconAnchor=$(mainAnchor).prev('a[href*="pluginfile.php"]');$(this).after('<div class="ally-glossary-attachment-row"></div>');var container=$(this).next(".ally-glossary-attachment-row");container.append(iconAnchor),container.append(mainAnchor),$(this).remove()}));return placeHoldSelector(".entry .attachments .ally-glossary-attachment",glossaryFileMapping).done((function(){dfd.resolve()})),dfd.promise()},urlEncodeFilePath=function(filePath){var parts=filePath.split("/");for(var p in parts)parts[p]=encodeURIComponent(parts[p]);return parts.join("/")},placeHoldLessonGeneral=function(map,selectorPrefix){var dfd=$.Deferred();if(0===map.length)dfd.resolve();else for(var c in map){var path=urlEncodeFilePath(c);placeHoldSelector(selectorPrefix+'img[src*="'+path+'"], '+selectorPrefix+'a[href*="'+path+'"]',map).done((function(){dfd.resolve()}))}return dfd.promise()},placeHoldLessonModule=function(lessonFileMapping){var dfd=$.Deferred(),pageContentsMap=lessonFileMapping.page_contents,pageAnswersMap=lessonFileMapping.page_answers,pageResponsesMap=lessonFileMapping.page_responses;return function(pageContentsMap){return placeHoldLessonGeneral(pageContentsMap,"")}(pageContentsMap).then((function(){return function(pageAnswersMap){return placeHoldLessonGeneral(pageAnswersMap,".studentanswer table tr:nth-child(1) ")}(pageAnswersMap)})).then((function(){return function(pageResponsesMap){return placeHoldLessonGeneral(pageResponsesMap,".studentanswer table tr.lastrow ")}(pageResponsesMap)})).then((function(){dfd.resolve()})),dfd.promise()},placeHoldResourceModule=function(moduleFileMapping){var dfd=$.Deferred(),c=0,checkAllProcessed=function(){++c>=Object.keys(moduleFileMapping).length&&dfd.resolve()};for(var moduleId in moduleFileMapping){var pathHash=moduleFileMapping[moduleId].content;if($("body").hasClass("theme-snap")&&!$("body").hasClass("format-tiles"))var moduleEl=$("#module-"+moduleId+":not(.snap-native) .activityinstance .snap-asset-link a:first-of-type:not(.clickable-region)");else moduleEl=$("#module-"+moduleId+" .activity-instance a:first-of-type:not(.clickable-region,.editing_move)");if(moduleEl.find(".filter-ally-wrapper").length>0)checkAllProcessed();else{var data={isimage:!1,fileid:pathHash,url:$(moduleEl).attr("href")};renderTemplate(data,pathHash,moduleEl).done(checkAllProcessed)}}return dfd.promise()},buildContentIdent=function(component,table,field,id){return[component,table,field,id].join(":")},annotateSections=function(sectionMapping){var dfd=$.Deferred();for(var s in sectionMapping){var sectionId=sectionMapping[s],ident=buildContentIdent("course","course_sections","summary",sectionId);$(["#"+s+' > .content div[class*="summarytext"] .no-overflow',"body.theme-snap #"+s+" > .content > .summary > div > .no-overflow"].join(",")).attr("data-ally-richcontent",ident)}return dfd.resolve(),dfd.promise()};const annotateModuleIntros=function(introMapping,module,additionalSelectors){for(const i in introMapping){const annotation=introMapping[i],selectors=["body.path-mod-"+module+".cmid-"+i+" #intro > .no-overflow",self.config.moodleversion>=2023100900?"li.activity.modtype_"+module+"#module-"+i+" .activity-description .no-overflow > .no-overflow":"li.activity.modtype_"+module+"#module-"+i+" .description .no-overflow > .no-overflow","li.snap-activity.modtype_"+module+"#module-"+i+" .contentafterlink > .no-overflow"];if(additionalSelectors)for(const a in additionalSelectors)selectors.push(additionalSelectors[a].replace("{{i}}",i));$(selectors.join(",")).attr("data-ally-richcontent",annotation)}};var annotateLesson=function(mapping){var intros=mapping.intros;annotateModuleIntros(intros,"lesson",["li.snap-native.modtype_lesson#module-{{i}} .contentafterlink > .summary-text .no-overflow"]);var content=mapping.lesson_pages;for(var p in content)if("page-mod-lesson-edit"===document.body.id){var xpath='//a[@id="lesson-'+p+'"]//ancestor::table//tbody/tr/td/div[contains(@class, "no-overflow")]',annotation=content[p],node=getNodeByXpath(xpath);$(node).attr("data-ally-richcontent",annotation)}else{if(node=getNodeByXpath('//form[contains(@action, "continue.php")]//input[@name="pageid"]'))var pageId=$(node).val();else pageId=new URLSearchParams(window.location.search).get("pageid");if(pageId!=p)continue;annotation=content[p];$(["#page-mod-lesson-view #region-main .box.contents > .no-overflow","#page-mod-lesson-view #region-main form > fieldset > .fcontainer > .contents .no-overflow","li.snap-native.modtype_page#module-"+p+" .pagemod-content"].join(",")).attr("data-ally-richcontent",annotation)}Strings.get_strings([{key:"answer",component:"mod_lesson"},{key:"response",component:"mod_lesson"}]).then((function(strings){var answerLabel=strings[0],responseLabel=strings[1],answers=mapping.lesson_answers,processAnswerResponse=function(pageId,i,label,annotation){var nodes=function(xpath){var result=window.document.createExpression(xpath).evaluate(window.document,XPathResult.ANY_TYPE),nodes=[];do{var node=result.iterateNext();nodes.push(node)}while(node);return nodes}('//a[@id="lesson-'+pageId+'"]//ancestor::table//td/label[contains(text(),"'+label+" "+i+'")]/ancestor::tr/td[2]');for(var n in nodes){var node=nodes[n];$(node).attr("data-ally-richcontent",annotation)}};for(var a in answers){var annotation=answers[a],pageId=(tmpArr=a.split("_"))[0],ansId=tmpArr[1],anum=tmpArr[2];if("page-mod-lesson-edit"===document.body.id)processAnswerResponse(pageId,anum,answerLabel,annotation);else{if($('#page-mod-lesson-view label[for="id_answerid_'+ansId+'"]').attr("data-ally-richcontent",annotation),self.params.answerid&&self.params.answerid==ansId)$(".studentanswer tr:nth-of-type(1) > td div").attr("data-ally-richcontent",annotation);else{var answerWrapperId="answer_wrapper_"+ansId,answerEl=$("#id_answerid_"+ansId);if(1!=answerEl.data("annotated")){var contentEls=answerEl.nextAll();answerEl.parent("label").append('<span id="answer_wrapper_'+ansId+'"></span>'),$("#"+answerWrapperId).append(contentEls)}answerEl.data("annotated",1)}$("#answer_wrapper_"+a).attr("data-ally-richcontent",annotation)}}var responses=mapping.lesson_answers_response;for(var r in responses){annotation=responses[r],pageId=(tmpArr=r.split("_"))[0];var tmpArr,respId=tmpArr[1],rnum=tmpArr[2];if("page-mod-lesson-edit"===document.body.id)processAnswerResponse(pageId,rnum,responseLabel,annotation);else if(self.params.answerid&&self.params.answerid==respId){var responseWrapperId="response_wrapper_"+respId;if(!$(".studentanswer tr.lastrow > td #"+responseWrapperId).length){contentEls=$(".studentanswer tr.lastrow > td > br").nextAll();$(".studentanswer tr.lastrow > td > br").after('<span id="'+responseWrapperId+'"></span>'),$("#"+responseWrapperId).append(contentEls)}$("#"+responseWrapperId).attr("data-ally-richcontent",annotation)}}}))},annotateModules=function(moduleMapping){var dfd=$.Deferred();return void 0!==moduleMapping.mod_forum&&function(forumMapping){var intros=forumMapping.intros;annotateModuleIntros(intros,"forum");var discussions=forumMapping.posts;for(var d in discussions){var post="p"+d,annotation=discussions[d];$(["#page-mod-forum-discuss #"+post+" div.forumpost div.no-overflow"].join(",")).attr("data-ally-richcontent",annotation)}}(moduleMapping.mod_forum),void 0!==moduleMapping.mod_hsuforum&&function(forumMapping){var intros=forumMapping.intros;annotateModuleIntros(intros,"hsuforum",["#hsuforum-header .hsuforum_introduction > .no-overflow"]);var discussions=forumMapping.posts;for(var d in discussions){var annotation=discussions[d];$('article[id="p'+d+'"] div.posting').attr("data-ally-richcontent",annotation)}}(moduleMapping.mod_hsuforum),void 0!==moduleMapping.mod_glossary&&function(mapping){var intros=mapping.intros;annotateModuleIntros(intros,"glossary");var entries=mapping.entries;for(var e in entries){var annotation=entries[e],entryFooter=$('.entrylowersection .commands a[href*="id='+e+'"]'),entry=$(entryFooter).parents(".glossarypost").find(".entry .no-overflow");$(entry).attr("data-ally-richcontent",annotation)}}(moduleMapping.mod_glossary),void 0!==moduleMapping.mod_page&&function(mapping){var intros=mapping.intros;annotateModuleIntros(intros,"page",["li.snap-native.modtype_page#module-{{i}} .contentafterlink > .summary-text"]);var content=mapping.content;for(var c in content){var annotation=content[c],selectors=["#page-mod-page-view.cmid-".concat(c," #region-main .box.generalbox > .no-overflow"),"li.snap-native.modtype_page#module-".concat(c," .pagemod-content")];$(selectors.join(",")).attr("data-ally-richcontent",annotation)}}(moduleMapping.mod_page),void 0!==moduleMapping.mod_book&&function(mapping){var intros=mapping.intros;annotateModuleIntros(intros,"book",["li.snap-native.modtype_book#module-{{i}} .contentafterlink > .summary-text .no-overflow"]);var chapterId,content=mapping.chapters;if(self.params.chapterid)chapterId=self.params.chapterid;else{var urlParams=new URLSearchParams(window.location.search);chapterId=urlParams.get("chapterid")}$.each(content,(function(ch,annotation){chapterId==ch&&$(["#page-mod-book-view #region-main .box.generalbox.book_content > .no-overflow","li.snap-native.modtype_page#module-"+ch+" .pagemod-content"].join(",")).attr("data-ally-richcontent",annotation)}))}(moduleMapping.mod_book),void 0!==moduleMapping.mod_lesson&&annotateLesson(moduleMapping.mod_lesson),dfd.resolve(),dfd.promise()},annotateSnapCourseSummary=function(mapping){var dfd=$.Deferred(),snapFooterCourseSummary=$("#snap-course-footer-summary > div.no-overflow");if(snapFooterCourseSummary.length){var ident=buildContentIdent("course","course","summary",mapping.courseId);snapFooterCourseSummary.attr("data-ally-richcontent",ident)}return dfd.resolve(),dfd.promise()},annotateHtmlBlock=function(mapping){var dfd=$.Deferred(),items=mapping.block_html;for(var i in items){var ident=items[i],selector=["#inst"+i+".block_html > .card-body > .card-text > .no-overflow","#inst"+i+".block_html > .content > .no-overflow"].join(",");$(selector).attr("data-ally-richcontent",ident)}return dfd.resolve(),dfd.promise()},debounceApplyPlaceHolders=Util.debounce((function(){return function(){M.util.js_pending("filter_ally_applyPlaceHolders");var dfd=$.Deferred();if(void 0===ally_module_maps||void 0===ally_section_maps)return dfd.resolve(),dfd.promise();var tasks=[{mapVar:ally_module_maps.file_resources,method:placeHoldResourceModule},{mapVar:ally_module_maps.assignment_files,method:placeHoldAssignModule},{mapVar:ally_module_maps.folder_files,method:placeHoldFolderModule},{mapVar:ally_module_maps.forum_files,method:placeHoldForumModule},{mapVar:ally_module_maps.glossary_files,method:placeHoldGlossaryModule},{mapVar:ally_module_maps.lesson_files,method:placeHoldLessonModule},{mapVar:ally_section_maps,method:annotateSections},{mapVar:ally_annotation_maps,method:annotateModules},{mapVar:{courseId:self.courseId},method:annotateSnapCourseSummary},{mapVar:ally_annotation_maps,method:annotateHtmlBlock}];return $(document).ready((function(){var completed=0,onTaskComplete=function(){++completed===tasks.length&&(M.util.js_complete("filter_ally_applyPlaceHolders"),dfd.resolve())};for(var t in tasks){var task=tasks[t];Object.keys(task.mapVar).length>0?task.method(task.mapVar).done(onTaskComplete):onTaskComplete()}})),dfd.promise()}()}),1e3);this.initStageTwo=function(){const{jwt:jwt,config:config}=self;(self.canViewFeedback||self.canDownload)&&(debounceApplyPlaceHolders().done((function(){ImageCover.init(),Ally.init(jwt,config);try{var targetNode=$(".foldertree > .filemanager")[0];if(targetNode){new MutationObserver((function(mutationsList){mutationsList.filter((function(mutation){return"childList"===mutation.type})).forEach((function(){placeHoldFolderModule(ally_module_maps.folder_files)}))})).observe(targetNode,{attributes:!0,childList:!0,subtree:!0})}}catch(error){setInterval((function(){placeHoldFolderModule(ally_module_maps.folder_files)}),5e3)}self.initialised=!0})),$(document).ajaxComplete((function(){self.initialised&&debounceApplyPlaceHolders()})),$("body.theme-snap").length&&($(document).ajaxComplete((function(event,xhr,settings){settings.url.includes("ally.js")&&(setTimeout((function(){$(".ally-feedback.ally-active.ally-score-indicator-embedded span").each((function(){"none"==this.style.display&&(this.style.display="block","ally-scoreindicator-container"==this.getAttribute("class")&&(this.style.display="inline-block",this.children[0].style.display="inline-block"))}))}),5e3),$(document).off("ajaxComplete"))})),document.addEventListener("core_filters/contentUpdated",(()=>{self.initStageTwo()}))))},this.init=function(jwt,config,canViewFeedback,canDownload,courseId,params){self.canViewFeedback=canViewFeedback,self.canDownload=canDownload,self.courseId=courseId,self.params=params,self.jwt=jwt,self.config=config;var pluginJSURL=function(path){return M.cfg.wwwroot+"/pluginfile.php/"+M.cfg.contextid+"/filter_ally/"+path},polyfills={};if(document.evaluate||(polyfills["filter_ally/wgxpath"]=pluginJSURL("vendorjs/wgxpath.install")),"undefined"==typeof URLSearchParams&&(polyfills["filter_ally/urlsearchparams"]=["https://cdnjs.cloudflare.com/ajax/libs/url-search-params/1.1.0/url-search-params.amd.js",pluginJSURL("vendorjs/url-search-params.amd")]),polyfills==={})self.initStageTwo();else{require.config({enforceDefine:!1,paths:polyfills});var requires=Object.keys(polyfills);require(requires,(function(){"undefined"==typeof URLSearchParams&&(window.URLSearchParams=arguments[1]),self.initStageTwo()}))}}}}));

//# sourceMappingURL=main.min.js.map